﻿#region Copyright PwC SDC 2012
//
// All rights are reserved. Reproduction or transmission in whole or in part, in
// any form or by any means, electronic, mechanical or otherwise, is prohibited
// without the prior written consent of the copyright owner.
// Created By: Charlie Shao
// Created Date: 11 22 2012
// Modification history:
//
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Data;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;
using System.Windows.Markup;


namespace SilverlightApplication27
{
    public class AddDynamicColumns
    {
        public static void AddColumns(GridViewDataControl control, Dictionary<string, DataColumn> TemplateFields)
        {

            #region For duplicate checking. 
            //clear column group
            List<string> groupNames = new List<string>();
            List<KeyValuePair<string, DataColumn>> templateFieldsList = TemplateFields.Where(p => p.Value.IsHidden == false).ToList();
            int sureColumnsCount = 0;

            //delete not existing columns
            if (control.Columns != null)
            {
                List<GridViewColumn> toBeRemoved = new List<GridViewColumn>();

                foreach (var col in control.Columns)
                {

                    if (col.UniqueName != null)
                    {
                        if (col.UniqueName.StartsWith("TemplateValues["))
                        {

                            KeyValuePair<string, DataColumn> existedItem = templateFieldsList
                            .FirstOrDefault(en =>
                            {
                                return col.UniqueName == string.Format("TemplateValues[{0}]", en.Key);
                            });

                            if (string.IsNullOrEmpty(existedItem.Key) == false
                                || existedItem.Value == null
                                || existedItem.Value.ColumnVisible != null)
                            {
                                toBeRemoved.Add(col);
                            }
                        }
                        else
                        {
                            sureColumnsCount++;
                        }
                    }
                    else
                    {
                        sureColumnsCount++;
                    }
                }

                //remove not existing columns
                control.Columns.RemoveItems(toBeRemoved);
            }
            #endregion
       

            #region  dynamic Add Column and mapping

            foreach (KeyValuePair<string, DataColumn> field in templateFieldsList)
            {

                DataColumn dc = field.Value;




                bool existed = false;
                int currentIndex = templateFieldsList.IndexOf(field) + sureColumnsCount;

                //update existing columns
                if (control.Columns != null
                    && control.Columns.Count != 0)
                {
                    foreach (var originalColumn in control.Columns)
                    {
                        string strName = String.Format("TemplateValues[{0}]", field.Key);
                        if (originalColumn.UniqueName == strName)
                        {
                            existed = true;

                            int originalIndex = control.Columns.IndexOf(originalColumn);

                            if (originalIndex != currentIndex)
                            {
                                control.Columns.Remove(originalColumn);
                                control.Columns.Insert(currentIndex, originalColumn);
                                break;
                            }
                        }
                    }
                }

                //insert new columns
                if (existed == false)
                {
                    if (field.Key == "1")
                    {
                        GridViewComboBoxColumn column = new GridViewComboBoxColumn();
                        column.Header = field.Value.Caption;
                        //data member binding 
                        //Binding dataMemberBinding = new Binding("MyID");
						Binding dataMemberBinding = new Binding(string.Format("Properties[{0}]", "MyID"));
                        column.DataMemberBinding = dataMemberBinding;

                        //Items Source Binding 
                        Binding itemBinding = new Binding(string.Format("TemplateDropDownValues[{0}]", field.Key));
                        column.ItemsSourceBinding = itemBinding;

                        column.DisplayMemberPath = "Name";
						column.SelectedValueMemberPath = "ID";

                        control.Columns.Insert(currentIndex, column);
                    }
                    else if (field.Key == "2")
                    {
                        GridViewDataColumn column = new GridViewDataColumn();
                        column.Header = field.Value.Caption;
                        Binding bind = new Binding(String.Format("TemplateValues[{0}]", field.Key));
                        column.DataMemberBinding = bind;
                        control.Columns.Insert(currentIndex, column);
                    }
                }
            }

            control.UpdateLayout();
            #endregion
        }
       
    }
}
