﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using Telerik.Windows.Controls;
using System.Windows.Data;
using System.Text;
using System.Windows.Markup;

namespace SilverlightApplication27
{
    public class ExtendedRadTreeListView : RadTreeListView
    {


        private Dictionary<string, DataColumn> TemplateFields
        {
            get;
            set;
        }

        public Dictionary<string, DataColumn> DynamicColumns
        {
            get
            {
                return (Dictionary<string, DataColumn>)GetValue(DynamicColumnsProperty);
            }
            set
            {
                SetValue(DynamicColumnsProperty, value);
            }
        }

        public static readonly DependencyProperty DynamicColumnsProperty = DependencyProperty
                                                                            .Register("DynamicColumns"
                                                                                        , typeof(Dictionary<string, DataColumn>)
                                                                                        , typeof(ExtendedRadTreeListView), new PropertyMetadata(OnDynamicColumnsChanged));

        private static void OnDynamicColumnsChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            ExtendedRadTreeListView grid = d as ExtendedRadTreeListView;
            if (e.NewValue != null && e.NewValue is Dictionary<string, DataColumn>)
            {
                grid.TemplateFields = (e.NewValue as Dictionary<string, DataColumn>);
                AddDynamicColumns.AddColumns(grid, grid.TemplateFields);
            }
        }


      

      
       
             
          
    }
}